
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>[转]ANDROID开发之SQLite详解 / 憋错料</title>

    <meta name="description" content="[转]ANDROID开发之SQLite详解 SQLite简介 Google为Andriod的较大的数据处理提供了SQLite,他在数据存储.管理.维护等各方面都相当出色,功能也非常的强大.SQLite具备下列特点: 1.轻量级 使用 SQLite 只需要带一个动态库,就可以享受它的全部功能,而且那个动态库的尺寸想当小. 2.独立性 SQLite 数据库的核心引擎不需要依赖第三方软件,也不需要所谓的“安装”. 3.隔离性 SQLite 数据库中所有的信息(比如表.视图.触发器等)都包含在一个文件夹内,方便管理和维护. 4.跨平台 SQLit">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">[转]ANDROID开发之SQLite详解</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<h4>SQLite简介</h4>
<p>Google为Andriod的较大的数据处理提供了SQLite，他在数据存储、管理、维护等各方面都相当出色，功能也非常的强大。SQLite具备下列特点：</p>
<p><strong>1.轻量级</strong></p>
<p>使用 SQLite 只需要带一个动态库，就可以享受它的全部功能，而且那个动态库的尺寸想当小。</p>
<p><strong>2.独立性</strong></p>
<p>SQLite 数据库的核心引擎不需要依赖第三方软件，也不需要所谓的&ldquo;安装&rdquo;。</p>
<p><strong>3.隔离性</strong></p>
<p>SQLite 数据库中所有的信息（比如表、视图、触发器等）都包含在一个文件夹内，方便管理和维护。</p>
<p><strong>4.跨平台</strong></p>
<p>SQLite 目前支持大部分操作系统，不至电脑操作系统更在众多的手机系统也是能够运行，比如：Android。</p>
<p><strong>5.多语言接口</strong></p>
<p>SQLite 数据库支持多语言编程接口。</p>
<p><strong>6.安全性</strong></p>
<p>SQLite 数据库通过数据库级上的独占性和共享锁来实现独立事务处理。这意味着多个进程可以在同一时间从同一数据库读取数据，但只能有一个可以写入数据。</p>
<h4>Android中的SQLite使用</h4>
<p>首先创建数据库类</p>
<table>
<tbody>
<tr>
<td>
<p><code>public</code> <code>class</code> <code>DatabaseHelper </code><code>extends</code> <code>SQLiteOpenHelper {</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>private</code> <code>static</code> <code>final</code> <code>String DB_NAME = </code><code>"mydata.db"</code><code>; </code><code>//数据库名称</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>private</code> <code>static</code> <code>final</code> <code>int</code> <code>version = </code><code>1</code><code>; </code><code>//数据库版本</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>public</code> <code>DatabaseHelper(Context context) {</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>super</code><code>(context, DB_NAME, </code><code>null</code><code>, version);</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>// TODO Auto-generated constructor stub</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>}</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>@Override</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>public</code> <code>void</code> <code>onCreate(SQLiteDatabase db) {</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>String sql = </code><code>"create table user(username varchar(20) not null , password varchar(60) not null );"</code><code>;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>db.execSQL(sql);</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>}</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>@Override</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>public</code> <code>void</code> <code>onUpgrade(SQLiteDatabase db, </code><code>int</code> <code>oldVersion, </code><code>int</code> <code>newVersion) {</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>// TODO Auto-generated method stub</code></p>

<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>}</code></p>

<p><code>}</code></p>
</td>
</tr>
</tbody>
</table>
<p><strong>SQLiteOpenHelper类介绍</strong></p>
<p>SQLiteOpenHelper是SQLiteDatabase的一个帮助类，用来管理数据库的创建和版本的更新。一般是建立一个类继承它，并实现它的onCreate和onUpgrade方法。</p>
<table>
<tbody>
<tr>
<th>方法名</th>
<th>方法描述</th>
</tr>
<tr>
<td>SQLiteOpenHelper(Context context,String name,SQLiteDatabase.CursorFactory factory,int version)</td>
<td>构造方法，一般是传递一个要创建的数据库名称那么参数</td>
</tr>
<tr>
<td>onCreate(SQLiteDatabase db)</td>
<td>创建数据库时调用</td>
</tr>
<tr>
<td>onUpgrade(SQLiteDatabase db,int oldVersion , int newVersion)</td>
<td>版本更新时调用</td>
</tr>
<tr>
<td>getReadableDatabase()</td>
<td>创建或打开一个只读数据库</td>
</tr>
<tr>
<td>getWritableDatabase()</td>
<td>创建或打开一个读写数据库</td>
</tr>
</tbody>
</table>
<p>下面来介绍调用的方法</p>
<p><strong>创建数据库</strong></p>
<p>这里特别的地方是通过调用了SQLiteOpenHelper类的getReadableDatabase()方法来实现创建一个数据库的</p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3
</td>
<td>
<p><code>DatabaseHelper database = </code><code>new</code> <code>DatabaseHelper(</code><code>this</code><code>);</code><code>//这段代码放到Activity类中才用this</code></p>
<p><code>SQLiteDatabase db = </code><code>null</code><code>;</code></p>
<p><code>db = database.getReadalbeDatabase();</code></p>
</td>
</tr>
</tbody>
</table>
<p>SQLiteDatabase类为我们提供了很多种方法，而较常用的方法如下</p>
<table>
<tbody>
<tr>
<th>（返回值）方法名</th>
<th>方法描述</th>
</tr>
<tr>
<td>(int) delete(String table,String whereClause,String[] whereArgs)</td>
<td>删除数据行的便捷方法</td>
</tr>
<tr>
<td>(long) insert(String table,String nullColumnHack,ContentValues values)</td>
<td>添加数据行的便捷方法</td>
</tr>
<tr>
<td>(int) update(String table, ContentValues values, String whereClause, String[] whereArgs)</td>
<td>更新数据行的便捷方法</td>
</tr>
<tr>
<td>(void) execSQL(String sql)</td>
<td>执行一个SQL语句，可以是一个select或其他的sql语句</td>
</tr>
<tr>
<td>(void) close()</td>
<td>关闭数据库</td>
</tr>
<tr>
<td>(Cursor) query(String table, String[] columns, String selection, String[] selectionArgs, String groupBy, String having, String orderBy, String limit)</td>
<td>查询指定的数据表返回一个带游标的数据集</td>
</tr>
<tr>
<td>(Cursor) rawQuery(String sql, String[] selectionArgs)</td>
<td>运行一个预置的SQL语句，返回带游标的数据集（与上面的语句最大的区别就是防止SQL注入）</td>
</tr>
</tbody>
</table>
<p>数据的添删改查分别可以通过2种途径来实现</p>
<p><strong>数据的添加</strong></p>
<p>1.使用insert方法</p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3
</td>
<td>
<p><code>ContentValues cv = </code><code>new</code> <code>ContentValues();</code><code>//实例化一个ContentValues用来装载待插入的数据cv.put("username","Jack Johnson");//添加用户名</code></p>
<p><code>cv.put(</code><code>"password"</code><code>,</code><code>"iLovePopMusic"</code><code>); </code><code>//添加密码</code></p>
<p><code>db.insert(</code><code>"user"</code><code>,</code><code>null</code><code>,cv);</code><code>//执行插入操作</code></p>
</td>
</tr>
</tbody>
</table>
<p>2.使用execSQL方式来实现</p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2
</td>
<td>
<p><code>String sql = "insert into user(username,password) values (</code><code>‘Jack Johnson‘</code><code>,</code><code>‘iLovePopMuisc‘</code><code>);</code><code>//插入操作的SQL语句</code></p>
<p><code>db.execSQL(sql);</code><code>//执行SQL语句</code></p>
</td>
</tr>
</tbody>
</table>
<p><strong>数据的删除</strong></p>
<p>同样有2种方式可以实现</p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3
</td>
<td>
<p><code>String whereClause = </code><code>"username=?"</code><code>;</code><code>//删除的条件</code></p>
<p><code>String[] whereArgs = {</code><code>"Jack Johnson"</code><code>};</code><code>//删除的条件参数</code></p>
<p><code>db.delete(</code><code>"user"</code><code>,whereClause,whereArgs);</code><code>//执行删除</code></p>
</td>
</tr>
</tbody>
</table>
<p>使用execSQL方式的实现</p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2
</td>
<td>
<p><code>String sql = </code><code>"delete from user where username=‘Jack Johnson‘"</code><code>;</code><code>//删除操作的SQL语句</code></p>
<p><code>db.execSQL(sql);</code><code>//执行删除操作</code></p>
</td>
</tr>
</tbody>
</table>
<p><strong>数据修改</strong></p>
<p>同上，仍是2种方式</p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3</p>
<p>4</p>
<p>5
</td>
<td>
<p><code>ContentValues cv = </code><code>new</code> <code>ContentValues();</code><code>//实例化ContentValues</code></p>
<p><code>cv.put(</code><code>"password"</code><code>,</code><code>"iHatePopMusic"</code><code>);</code><code>//添加要更改的字段及内容</code></p>
<p><code>String whereClause = </code><code>"username=?"</code><code>;</code><code>//修改条件</code></p>
<p><code>String[] whereArgs = {</code><code>"Jack Johnson"</code><code>};</code><code>//修改条件的参数</code></p>
<p><code>db.update(</code><code>"user"</code><code>,cv,whereClause,whereArgs);</code><code>//执行修改</code></p>
</td>
</tr>
</tbody>
</table>
<p>使用execSQL方式的实现</p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2
</td>
<td>
<p><code>String sql = </code><code>"update [user] set password = ‘iHatePopMusic‘ where username=‘Jack Johnson‘"</code><code>;</code><code>//修改的SQL语句</code></p>
<p><code>db.execSQL(sql);</code><code>//执行修改</code></p>
</td>
</tr>
</tbody>
</table>
<p><strong>数据查询</strong></p>
<p>数据查询相对前面几种方法就复杂一些了，因为查询会带有很多条件</p>
<p>通过query实现查询的</p>
<p>public Cursor query(String table, String[] columns, String selection, String[] selectionArgs, String groupBy, String having, String orderBy, String limit)</p>
<p>各参数说明：</p>
<ul>
<li>table：表名称</li>
<li>colums：列名称数组</li>
<li>selection：条件子句，相当于where</li>
<li>selectionArgs：条件语句的参数数组</li>
<li>groupBy：分组</li>
<li>having：分组条件</li>
<li>orderBy：排序类</li>
<li>limit：分页查询的限制</li>
<li>Cursor：返回值，相当于结果集ResultSet</li>
</ul>
<p>针对游标（Cursor）也提供了不少方法</p>
<table>
<tbody>
<tr>
<th>方法名称</th>
<th>方法描述</th>
</tr>
<tr>
<td>getCount()</td>
<td>总记录条数</td>
</tr>
<tr>
<td>isFirst()</td>
<td>判断是否第一条记录</td>
</tr>
<tr>
<td>isLast()</td>
<td>判断是否最后一条记录</td>
</tr>
<tr>
<td>moveToFirst()</td>
<td>移动到第一条记录</td>
</tr>
<tr>
<td>moveToLast()</td>
<td>移动到最后一条记录</td>
</tr>
<tr>
<td>move(int offset)</td>
<td>移动到指定的记录</td>
</tr>
<tr>
<td>moveToNext()</td>
<td>移动到吓一条记录</td>
</tr>
<tr>
<td>moveToPrevious()</td>
<td>移动到上一条记录</td>
</tr>
<tr>
<td>getColumnIndex(String columnName)</td>
<td>获得指定列索引的int类型值</td>
</tr>
</tbody>
</table>
<p>实现代码</p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3</p>
<p>4</p>
<p>5</p>
<p>6</p>
<p>7</p>
<p>8
</td>
<td>
<p><code>Cursor c = db.query(</code><code>"user"</code><code>,</code><code>null</code><code>,</code><code>null</code><code>,</code><code>null</code><code>,</code><code>null</code><code>,</code><code>null</code><code>,</code><code>null</code><code>);</code><code>//查询并获得游标</code></p>
<p><code>if</code><code>(c.moveToFirst()){</code><code>//判断游标是否为空</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>for</code><code>(</code><code>int</code> <code>i=</code><code>0</code><code>;i&lt;c.getCount();i++){</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>c.move(i);</code><code>//移动到指定记录</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>String username = c.getString(c.getColumnIndex(</code><code>"username"</code><code>);</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>String password = c.getString(c.getColumnIndex(</code><code>"password"</code><code>));</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>}</code></p>
<p><code>}</code></p>
</td>
</tr>
</tbody>
</table>
<p>通过rawQuery实现的带参数查询</p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3</p>
<p>4
</td>
<td>
<p><code>Cursor c = db.rawQuery(</code><code>"select * from user where username=?"</code><code>,</code><code>new</code> <code>Stirng[]{</code><code>"Jack Johnson"</code><code>});</code></p>
<p><code>if</code><code>(cursor.moveToFirst()) {</code></p>
<p><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>String password = c.getString(c.getColumnIndex(</code><code>"password"</code><code>));</code></p>
<p><code>}</code></p>
</td>
</tr>
</tbody>
</table>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 23:48:21 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>[转]ANDROID开发之SQLite详解的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MVqvny4.html" rel="bookmark">ANDROID开发之SQLite详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				===================== 转自:http://www.cnblogs.com/Excellent/archive/2011/11/19/2254888.html ===================== SQLite简介 Google为Andriod的较大的数据处理提供了SQLite,他在数据存储.管理.维护等各方面都相当出色,功能也非常的强大.SQLite具备下列特点: 1.轻量级 使用 SQLite 只需要带一个动态库,就可以享受它的全部功能,而且那个动态库的尺寸想当小.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3vK6lk4.html" rel="bookmark">Android开发之SpannableString详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在实际的应用开发过程中经常会遇到,在文本的不同部分显示一些不同的字体风格的信息如:文本的字体.大小.颜色.样式.以及超级链接等.一般情况下,TextView中的文本都是一个样式,对于类似的情况,可以借助SpannableString或SpannableStringBuilder对象来实现以上设置. SpannableString与SpannableStringBuilder都可以将某段文本设置成一个Span,在Android中,Span表示一段文本的效果,例如,链接形式.图像.带背景的文本等.只			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MgPWNn0.html" rel="bookmark">Android开发之InstanceState详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Android开发之InstanceState详解 本文介绍Android中关于Activity的两个神秘方法:onSaveInstanceState() 和 onRestoreInstanceState(),并且在介绍这两个方法之后,再分别来实现使用InstanceState保存和恢复数据功能.Android实现屏幕旋转异步下载效果这样两个示例. 首先来介绍onSaveInstanceState() 和 onRestoreInstanceState() .关于这两个方法,一些朋友可能在Andr			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Mz1BzA4.html" rel="bookmark">Android开发之WebView详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				概述: 一个显示网页的视图.这个类是你可以滚动自己的Web浏览器或在你的Activity中简单地显示一些在线内容的基础.它使用了WebKit渲染引擎来显示网页,包括向前和向后导航的方法(通过历史记录),放大和缩小,执行文本搜索等. 需要注意的是:为了让你的应用能够使用WebView访问互联网和加载网页,你必须添加Internet的权限在Android Manifest文件中: &lt;uses-permission android:name=&quot;android.permission.INTERNE			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0k1yG74.html" rel="bookmark">Android开发之BroadcastReceiver详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				BroadcastReceiver,顾名思义就是&quot;广播接收者&quot;的意思,它是Android四大基本组件之一,这种组件本质上是一种全局的监听器,用于监听系统全局的广播消息.它可以接收来自系统和应用的的广播. 由于BroadcastReceiver是一种全局的监听器,因此它可以非常方便地实现系统不同组件之间的通信.比如Activity与通过startService()方法启动的Service之间通信,就可以借助于BroadcastReceiver来实现. BroadcastReceiver简			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MokVAwM.html" rel="bookmark">Android开发之InstanceState详解&lpar;转&rpar;---利用其保存Activity状态</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Android开发之InstanceState详解 本文介绍Android中关于Activity的两个神秘方法:onSaveInstanceState() 和 onRestoreInstanceState(),并且在介绍这两个方法之后,再分别来实现使用InstanceState保存和恢复数据功能.Android实现屏幕旋转异步下载效果这样两个示例. 首先来介绍onSaveInstanceState() 和 onRestoreInstanceState() .关于这两个方法,一些朋友可能在Andr			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/388qJK3.html" rel="bookmark">Android开发之Fragment详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Android开发之Fragment学习 1.简介: Fragment是Android 3.0引入的新API. Fragment代表了 Activity的子模块,因此可以把Fragment理解成Activity片段.Fragment用于自己的生命周期,也可以接受它自己的输入事件. Fragment必须被&quot;嵌入&quot; Activity中使用,因此虽然Fragment也拥有自己的生命周期,但Fragment的生命周期会受它所在的Activity的生命周期的控制.例如,当Activity暂停时,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0eYV6a0.html" rel="bookmark">android开发之service详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				service作为android的四大组件之一,其重要性可想而知,在开发中,我们经常把一些不需要与用户进行交互的工作放在service中来完成,service运行在后台,这样有些人可能会产生错觉,以为service是运行在新线程中,其实不然,service也运行在主线程中,因此不能在service中进行耗时操作,否则会报ANR异常,但是我们可以在service中新开线程来进行耗时操作,比如下载等等. 先来说说service的两种绑定方式,一种是通过Context.startService()来启			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xvRbN4.html" rel="bookmark">Android开发之MdiaPlayer详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				MediaPlayer类可用于控制音频/视频文件或流的播放,我曾在&lt;Android开发之基于Service的音乐播放器&gt;一文中介绍过它的使用.下面让我们看一下MediaPlayer类的详细介绍. 一.类结构: java.lang.Object    ? android.media.MediaPlayer 二.构造方法和公有方法 构造方法: Public Constructors   MediaPlayer() 默认构造方法. 公有方法: Public Methods static MediaP			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/W0jxWZ4.html" rel="bookmark" class="title">《我是一只IT小小鸟读后感》</a>
					<div>
						在上大学之前,我对软件工程是一个什么专业根本了解不多,甚至有时感到很迷茫.在上完半学期之后还是对软件工程朦朦的,直至我读了&lt;我是一只IT小小鸟&gt;这本书,让我更深一步了解了IT行业. 让我体 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4QWRqB0.html" rel="bookmark" class="title">win10家庭版无法打开系统内置应用（录音机、日历等），如何解决&OpenCurlyDoubleQuote;内置管理员无法打开此应用&rdquo;的问题</a>
					<div>
						原先电脑是win8的,后来升级为win10家庭版本,有一些应用(录音机.应用商店等).文件就不能修改, 现在是解决内置管理员无法打开此应用的问题 1.按住键盘,Windows+R,按下之后,在里头输入 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vE2pg0.html" rel="bookmark" class="title">说说Python编码规范</a>
					<div>
						前言 已有近两个月没有发表过文章了,前段时间外甥和女儿过来这边渡暑假,平常晚上和周末时间都陪着她们了,趁这个周末有空,再抽空再把这块拾起来.         这么久没写了,再次拿起键盘,想想,发表些什 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vKgRZ4.html" rel="bookmark" class="title">sed基本用法</a>
					<div>
						Sed是行处理命令,处理的过程是逐行将需要处理数据读入到模式空间处理,处理完成打印(默认)模式空间内容并清空模式空间,所以除非是添加特殊参数(-i),否则sed是不会修改文本内容,参数(-n)是不打印 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZA5LG0.html" rel="bookmark" class="title">Git 项目上传至github入门实战并解决常见错误</a>
					<div>
						1.Git GUI 首先,在push到github的项目必须先建立版本(即creat  repository的名字一样),一般是先pull下来,再push(为了防止有其他人提交了代码,而你却不知道,造 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4A6AKDM.html" rel="bookmark" class="title">三星4412开发卡刷android系统</a>
					<div>
						使用SD卡烧写cpu核心为三星4412为核心的CortexA9的Android开发版. 1.准备一张4G或者是8G的SD卡. 2.使用Ubunt12.04下自到的fdisk工具对sd卡进行格式化成(W ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KODRy0.html" rel="bookmark" class="title">MD新控件笔记</a>
					<div>
						FloatingActionButton 由于FloatingActionButton是重写ImageView的,所有FloatingActionButton拥有ImageView的一切属性. 控制F ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/478Lq6M.html" rel="bookmark" class="title">Table行合并操作</a>
					<div>
						此方法不可取,但几天心血 保留,已有新想法,稍后会出一个完善的Table行列合并方法 &lt;!DOCTYPE html PUBLIC &quot;-//W3C//DTD XHTML 1.0 Tran ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MV7WQd0.html" rel="bookmark" class="title">Java中字符串indexof&lpar;&rpar; 的使用方法</a>
					<div>
						Java中字符串中子串的查找共有四种方法(indexof()) indexOf 方法返回一个整数值,指出 String 对象内子字符串的开始位置.如果没有找到子字符串,则返回-1.如果 startin ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lk8BEM.html" rel="bookmark" class="title">H3C 单臂路由配置 V7平台</a>
					<div>
						单臂路由实验 1.用二层交换机实现多个VLAN互通,每个VLAN属于不同子网; 2.路由器接口能够划分子接口,做单臂路由 路由器R1配置: sys sys r1 int g0/0.1 ip add 1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/471mxb0.html" rel="bookmark" class="title">C&num; 获取当前月第一天和最后一天 计算两个日期差多少天</a>
					<div>
						获取当前月的第一天和最后一天 DateTime now = DateTime.Now; DateTime firstDay = new DateTime(now.Year, now.Month, 1) ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MD8mP9M.html" rel="bookmark" class="title">JAVA中几种常见集合的使用实例</a>
					<div>
						Java.util.ArrayList(类): *;import java.util.*;public class CollectionTest{//List是一个能包含重复元素的已排序的Collec ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLvonk3.html" rel="bookmark" class="title">Beat &amp;&num;39&semi;Em Up Game Starter Kit &lpar;横版格斗游戏&rpar; cocos2d-x游戏源码出售</a>
					<div>
						请大家赏个脸,如果感兴趣的看一下,含金量非常高的横版格斗游戏源码,  我的淘宝网址: Beat 'Em Up Game 名将.恐龙.拳皇.三国战纪.战国传承,一个个响当当的名字,承载了80后多少儿时的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YqByw0.html" rel="bookmark" class="title">Redis 11种Web应用场景举例</a>
					<div>
						在&quot;怎样让redis在你的系统中发挥作用&quot;一文中,salvatore 'antirez' sanfilippo告诉我们如何利用redis独有的数据结构处理能力来解决一些常见问题.一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0Yq6gq0.html" rel="bookmark" class="title">linux c语言 rename的用法-rename&lpar;&rpar; does not work across different mount points&comma; even if the same file system is mounted on both</a>
					<div>
						最近在一个项目上执行文件的搬移功能时发现总是失败,临时录像文件存放于emmc的/tmp/目录下,当录像完成时候则调用rename企图将此文件搬到/mnt/sdcard/mmcblk1p1/(这是外置的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47emvD0.html" rel="bookmark" class="title">PHP基础教程 HTTP简介，http是一个属于应用层的面向对象的协议</a>
					<div>
						HTTP是一个属于应用层的面向对象的协议,由于其简捷.快速的方式,适用于分布式超媒体信息系统.它于1990年提出,经过几年的使用与发展,得到不断地完善和扩展.目前在WWW中使用的是HTTP/1.0的第 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVvq1xM.html" rel="bookmark" class="title">Linux运维学习历程-第六天-Linux用户、组以及权限管理</a>
					<div>
						本章内容 Linux的安全模型 用户和组 用户和组管理命令 文件权限 默认权限 特殊权限 ACL访问控制 一:3A认证 Authentication :认证 Authorization :授权 Aud ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Qagde4.html" rel="bookmark" class="title">根据兄弟元素的数量来设置样式&lpar;CSS揭秘学习笔记&rpar;</a>
					<div>
						CSS揭秘学习笔记 li.length == 4 li:first-child:nth-last-child(4), li:first-child:nth-last-child(4) ~ li { / ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OpXj84.html" rel="bookmark" class="title">oracle vm virtualbox安装centos并配置Java环境</a>
					<div>
						安装虚拟机 参考资料:https://opensourcedbms.com/dbms/installing-cent-os-6-3-linux-in-oracle-virtual-box-ssh-ac ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0neXpVM.html" rel="bookmark" class="title">c3p0三种配置方式（automaticTestTable）</a>
					<div>
						c3p0的配置方式分为三种,分别是http://my.oschina.net/lyzg/blog/551331.setters一个个地设置各个配置项2.类路径下提供一个c3p0.properties文 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.040 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
